### Hierarchy

- BaseForLines
  - SimpleTileWithModifier

### Implements

- ICacheable

## Index

### Constructors

- constructor

### Properties

- __coverageCount
- __source
- _debugFlag
- _direction
- _isNegated
- _isRandom
- _tile

### Methods

- __getLineAndColumnRange
- __getSourceLineAndColumn
- __incrementCoverage
- addCells
- clearCaches
- equals
- getCollisionLayers
- hasCell
- isNo
- isRandom
- removeCells
- subscribeToCellChanges
- toKey
- toSourceString
- toString
- updateCells

## Constructors

### constructor

- new SimpleTileWithModifier(source: IGameCode, isNegated: boolean, isRandom: boolean, direction: Optional<RULE_DIRECTION>, tile: IGameTile, debugFlag: Optional<DEBUG_FLAG>): SimpleTileWithModifier

- Overrides BaseForLines.constructor

  - Defined in models/rule.ts:450

  #### Parameters

  - ##### source: IGameCode

  - ##### isNegated: boolean

  - ##### isRandom: boolean

  - ##### direction: Optional<RULE_DIRECTION>

  - ##### tile: IGameTile

  - ##### debugFlag: Optional<DEBUG_FLAG>

  #### Returns SimpleTileWithModifier

## Properties

### __coverageCount

__coverageCount: Optional<number>

Inherited from BaseForLines.__coverageCount

- Defined in models/BaseForLines.ts:69

### __source

__source: IGameCode

Inherited from BaseForLines.__source

- Defined in models/BaseForLines.ts:68

### _debugFlag

_debugFlag: Optional<DEBUG_FLAG>

- Defined in models/rule.ts:448

### _direction

_direction: Optional<RULE_DIRECTION>

- Defined in models/rule.ts:446

### _isNegated

_isNegated: boolean

- Defined in models/rule.ts:444

### _isRandom

_isRandom: boolean

- Defined in models/rule.ts:445

### _tile

_tile: IGameTile

- Defined in models/rule.ts:447

## Methods

### __getLineAndColumnRange

- __getLineAndColumnRange(): object

- Inherited from BaseForLines.__getLineAndColumnRange

  - Defined in models/BaseForLines.ts:96

  #### Returns object

  - ##### end: object

    - ##### col: number

    - ##### line: number

  - ##### start: object

    - ##### col: number

    - ##### line: number

### __getSourceLineAndColumn

- __getSourceLineAndColumn(): object

- Inherited from BaseForLines.__getSourceLineAndColumn

  - Defined in models/BaseForLines.ts:81

  #### Returns object

  - ##### colNum: number

  - ##### line: string

  - ##### lineNum: number

  - ##### nextLine: null | string

  - ##### prevLine: null | string

### __incrementCoverage

- __incrementCoverage(): void

- Inherited from BaseForLines.__incrementCoverage

  - Defined in models/BaseForLines.ts:104

  #### Returns void

### addCells

- addCells(tile: IGameTile, sprite: GameSprite, cells: Cell[], wantsToMove: Optional<RULE_DIRECTION>): void

- - Defined in models/rule.ts:502

  #### Parameters

  - ##### tile: IGameTile

  - ##### sprite: GameSprite

  - ##### cells: Cell[]

  - ##### wantsToMove: Optional<RULE_DIRECTION>

  #### Returns void

### clearCaches

- clearCaches(): void

- - Defined in models/rule.ts:476

  #### Returns void

### equals

- equals(t: SimpleTileWithModifier): boolean

- - Defined in models/rule.ts:472

  #### Parameters

  - ##### t: SimpleTileWithModifier

  #### Returns boolean

### getCollisionLayers

- getCollisionLayers(): Set<CollisionLayer>

- - Defined in models/rule.ts:487

  #### Returns Set<CollisionLayer>

### hasCell

- hasCell(cell: Cell): boolean

- - Defined in models/rule.ts:596

  #### Parameters

  - ##### cell: Cell

  #### Returns boolean

### isNo

- isNo(): boolean

- - Defined in models/rule.ts:480

  #### Returns boolean

### isRandom

- isRandom(): boolean

- - Defined in models/rule.ts:483

  #### Returns boolean

### removeCells

- removeCells(tile: IGameTile, sprite: GameSprite, cells: Cell[]): void

- - Defined in models/rule.ts:566

  #### Parameters

  - ##### tile: IGameTile

  - ##### sprite: GameSprite

  - ##### cells: Cell[]

  #### Returns void

### subscribeToCellChanges

- subscribeToCellChanges(neighbor: SimpleNeighbor): void

- - Defined in models/rule.ts:496

  #### Parameters

  - ##### neighbor: SimpleNeighbor

  #### Returns void

### toKey

- toKey(ignoreDebugFlag?: undefined | false | true): string

- - Defined in models/rule.ts:463

  #### Parameters

  - ##### Optional ignoreDebugFlag: undefined | false | true

  #### Returns string

### toSourceString

- toSourceString(): string

- Inherited from BaseForLines.toSourceString

  - Defined in models/BaseForLines.ts:90

  #### Returns string

### toString

- toString(): string

- Inherited from BaseForLines.toString

  - Defined in models/BaseForLines.ts:85

  #### Returns string

### updateCells

- updateCells(sprite: GameSprite, cells: Cell[], wantsToMove: Optional<RULE_DIRECTION>): void

- - Defined in models/rule.ts:542

  #### Parameters

  - ##### sprite: GameSprite

  - ##### cells: Cell[]

  - ##### wantsToMove: Optional<RULE_DIRECTION>

  #### Returns void

Generated using TypeDoc